﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace RogueSharp
{
    class RogueSharpProgram
    {
        private static bool quit = false;
        private const int screenWidth = 80;
        private const int screenHeight = 24;
        private static int playerX;
        private static int playerY;

        static void Main(string[] args)
        {
            // Register Ctrl+C handler and hide the cursor
            Console.CancelKeyPress += ConsoleOnCancelKeyPress;
            Console.CursorVisible = false;

            // Initialize Game here
            InitializeGame();
            
            // Enter Game Loop
            GameLoop();
        }

        private static void InitializeGame()
        {
            // Set window size
            Console.SetWindowSize(screenWidth, screenHeight);
            Console.SetBufferSize(screenWidth, screenHeight);

            // Set initial player position to center of screen
            playerX = screenWidth/2;
            playerY = screenHeight/2;
        }

        private static void ConsoleOnCancelKeyPress(object sender, ConsoleCancelEventArgs consoleCancelEventArgs)
        {
            // Set flag that we'll use to cancel on our own terms
            quit = true;
            consoleCancelEventArgs.Cancel = true;
        }

        private static void GameLoop()
        {
            while (!quit)
            {
                // Sleep a short period at the end of each iteration of the loop
                Thread.Sleep(100);

                // Draw the player at the current position in white
                Console.SetCursorPosition(playerX, playerY);
                Console.ForegroundColor = ConsoleColor.White;
                Console.Write('@');

                // Wait for a key press and do not display key on the console
                ConsoleKeyInfo character = Console.ReadKey(true);

                // Handle the player input
                switch (character.KeyChar)
                {
                    case 'i':
                        playerY -= 1;
                        break;
                    case 'j':
                        playerX -= 1;
                        break;
                    case 'k':
                        playerX += 1;
                        break;
                    case 'm':
                        playerY += 1;
                        break;
                    case 'q':
                        quit = true;
                        break;
                }
            }
        }
    }
}
